#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire400eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 400"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight4004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight4004xi = {
                1:'-100x-265y-282z',
                2:'-102x-71y-379z',
                3:'-108x-131y-361z',
                4:'-109x-68y-378z',
                5:'-111x-300y-238z',
                6:'-111x-382y-35z',
                7:'-115x-262y-279z',
                8:'-115x-64y-377z',
                9:'-117x-128y-360z',
                10:'-11x-65y-394z',
                11:'-122x-60y-376z',
                12:'-126x-124y-358z',
                13:'-128x-296y-235z',
                14:'-128x-55y-374z',
                15:'-129x-258y-276z',
                16:'-12x-265y-298z',
                17:'-12x-305y-257z',
                18:'-131x-376y-31z',
                19:'-135x-120y-356z',
                20:'-135x-49y-373z',
                21:'-141x-43y-371z',
                22:'-144x-115y-354z',
                23:'-144x-253y-273z',
                24:'-144x-291y-232z',
                25:'-146x-36y-370z',
                26:'-14x-129y-378z',
                27:'-151x-369y-27z',
                28:'-152x-29y-368z',
                29:'-153x-109y-352z',
                30:'-157x-22y-367z',
                31:'-159x-247y-270z',
                32:'-15x-69y-393z',
                33:'-160x-285y-229z',
                34:'-161x-103y-350z',
                35:'-161x-14y-365z',
                36:'-170x-361y-23z',
                37:'-170x-96y-348z',
                38:'-173x-241y-267z',
                39:'-176x-278y-225z',
                40:'-178x-89y-346z',
                41:'-185x-81y-344z',
                42:'-187x-234y-264z',
                43:'-189x-351y-19z',
                44:'-192x-271y-222z',
                45:'-192x-72y-342z',
                46:'-199x-63y-340z',
                47:'-201x-225y-261z',
                48:'-205x-53y-338z',
                49:'-207x-262y-219z',
                50:'-207x-341y-15z',
                51:'-20x-71y-392z',
                52:'-214x-216y-258z',
                53:'-21x-131y-376z',
                54:'-222x-252y-215z',
                55:'-225x-330y-11z',
                56:'-227x-207y-255z',
                57:'-236x-242y-212z',
                58:'-240x-196y-252z',
                59:'-242x-318y-7z',
                60:'-250x-231y-209z',
                61:'-252x-185y-249z',
                62:'-258x-305y-3z',
                63:'-25x-74y-392z',
                64:'-263x-173y-246z',
                65:'-264x-218y-205z',
                66:'-26x-267y-295z',
                67:'-274x-160y-242z',
                68:'-274x-291y0z',
                69:'-276x-206y-202z',
                70:'-284x-146y-239z',
                71:'-288x-192y-198z',
                72:'-28x-307y-254z',
                73:'-293x-132y-236z',
                74:'-29x-134y-375z',
                75:'-29x-395y-51z',
                76:'-300x-177y-195z',
                77:'-302x-118y-233z',
                78:'-30x-76y-391z',
                79:'-310x-102y-230z',
                80:'-310x-162y-191z',
                81:'-317x-86y-226z',
                82:'-320x-147y-188z',
                83:'-324x-70y-223z',
                84:'-329x-130y-184z',
                85:'-329x-53y-220z',
                86:'-334x-36y-216z',
                87:'-337x-114y-181z',
                88:'-345x-96y-177z',
                89:'-351x-78y-173z',
                90:'-36x-78y-390z',
                91:'-37x-136y-374z',
                92:'-3x-58y-395z',
                93:'-41x-268y-293z',
                94:'-42x-79y-389z',
                95:'-45x-137y-372z',
                96:'-45x-307y-251z',
                97:'-48x-80y-388z',
                98:'-50x-393y-47z',
                99:'-54x-138y-371z',
                100:'-54x-81y-387z',
                101:'-55x-269y-290z',
                102:'-61x-307y-248z',
                103:'-61x-81y-386z',
                104:'-63x-138y-369z',
                105:'-67x-81y-385z',
                106:'-70x-268y-287z',
                107:'-70x-391y-43z',
                108:'-71x-138y-368z',
                109:'-74x-80y-384z',
                110:'-78x-306y-245z',
                111:'-7x-62y-395z',
                112:'-80x-137y-366z',
                113:'-81x-79y-383z',
                114:'-85x-267y-284z',
                115:'-88x-77y-382z',
                116:'-8x-395y-55z',
                117:'-90x-136y-365z',
                118:'-91x-387y-39z',
                119:'-94x-303y-242z',
                120:'-95x-74y-381z',
                121:'-99x-134y-363z',
                122:'-9x-157y-474z',
                123:'0x-55y-396z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire400eight4xi" usage = "target function for charge400eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire400eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE400EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE400EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE400EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE400EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE400EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight4004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE400EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE400EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE400EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight4004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight4004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE400EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE400EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE400EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire400eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  